
// uncommenting this line leads to terrible performance
if (arguments[0] === 'freeze') {
  console.log('freezing')
  Object.freeze(Uint8Array.prototype);
  console.log('frozen')
}

console.log('start')

let count = 0;

const run = () => {
  // throw away the assumption that a specific buffer size is optimized by adding count
  const x = new Uint8Array(10000 + count);
  for (let i = 0; i < x.length; i++) {
    x[i] = 1;
  }
  count++;
};

const runtime = 10 * 1000;
const experiment = () => {
  const start = Date.now();
  let now = Date.now();
  // run for a fixed time, count how many runs
  while (now - start < runtime) {
    run();
    now = Date.now();
  }
};

experiment();
console.log(count);

console.log('done')
